package v8.name.panitz.wip;

import v8.name.panitz.wip.Tree.Case;
import v8.name.panitz.wip.Tree.FieldSelect;
import v8.name.panitz.wip.Tree.FunCall;
import v8.name.panitz.wip.Tree.FunDef;
import v8.name.panitz.wip.Tree.IfExpr;
import v8.name.panitz.wip.Tree.Program;
import v8.name.panitz.wip.Tree.SwitchExpr;
import v8.name.panitz.wip.Tree.Variable;

public interface Visitor<R> {
	R visit(Tree.IntLiteral il);
	R visit(Tree.OpExpr oe);
	R visit(FunDef funDef);
	R visit(Tree.ConDef conDef);
	R visit(Tree.Param param);
	R visit(Program program);
	R visit(Variable variable);
	R visit(FunCall funCall);
	R visit(FieldSelect fieldSelect);
	R visit(IfExpr ifExpr);
  R visit(Case case1);
  R visit(SwitchExpr switchExpr);
}
