package v8.name.panitz.wip;
import org.antlr.v4.runtime.CharStreams;
import org.antlr.v4.runtime.CommonTokenStream;
import org.antlr.v4.runtime.tree.ParseTreeWalker;

import v8.name.panitz.wip.antlr.WipLexer;
import v8.name.panitz.wip.antlr.WipParser;
import v8.name.panitz.wip.antlr.*;

public class WipC {

  public static void main(String[] args) throws Exception {
    var codePointCharStream = CharStreams.fromFileName(args[0]);
    var lexer = new WipLexer(codePointCharStream);
    var parser = new WipParser(new CommonTokenStream(lexer));

    var tree = parser.startSymbol();
//    var walker = new ParseTreeWalker();
    ParseTreeWalker.DEFAULT.walk(new BuildTree(), tree);
    tree.result.welcome(new TypeCheck());
    tree.result.welcome(new FindTailRecursion());
    tree.result.welcome(new GenJBC(tree.result));
    tree.result.welcome(new GenCode());
  }

}
